<template>
    <div>
        <v-app>
            <v-container fluid>
                <v-flex xs12>
                    <v-layout>
                        <v-container>
                            <app-search @transmittedData="receivedData"></app-search>
                        </v-container>
                        <v-container>
                            <v-flex xs12>
                                <v-btn class="float-right" @click="routeToRegister" color="info">Register</v-btn>
                                <v-btn class="float-right" @click="routeToLogin" color="info">Login</v-btn>
                            </v-flex>
                        </v-container>
                    </v-layout>
                </v-flex>
                <v-flex xs3>
                   <v-layout>
                       <v-container>
                           <v-flex xs6>
                               <v-layout row justify-center>
                                   <v-dialog v-model="dialog" persistent max-width="600px">
                                       <template v-slot:activator="{ on }">
                                           <v-btn color="info" v-on="on">Create new task</v-btn>
                                       </template>
                                       <v-card>
                                           <v-card-title>
                                               <span class="headline">New Task</span>
                                           </v-card-title>
                                           <v-card-text>
                                               <v-container grid-list-md>
                                                   <v-layout wrap>
                                                       <v-flex xs12>
                                                           <v-text-field label="Task name" required v-model="taskName"></v-text-field>
                                                       </v-flex>
                                                       <v-flex xs12 sm12>
                                                           <v-textarea
                                                                   name="input-7-4"
                                                                   label="Description"
                                                                   v-model="taskDescription"
                                                           ></v-textarea>
                                                       </v-flex>
                                                   </v-layout>
                                               </v-container>
                                           </v-card-text>
                                           <v-card-actions>
                                               <v-spacer></v-spacer>
                                               <v-btn color="blue darken-1" flat @click="dialog = false">Close</v-btn>
                                               <v-btn color="blue darken-1" flat @click="addTask">Create</v-btn>
                                           </v-card-actions>
                                       </v-card>
                                   </v-dialog>
                               </v-layout>
                           </v-flex>
                       </v-container>
                   </v-layout>
                </v-flex>
                <draggable>
                    <v-layout row wrap v-for="(task, key) in tasks" :key="key">
                        <v-flex xs6 class="px-4">
                            <v-expansion-panel>
                                <v-expansion-panel-content>
                                    <template v-slot:actions>
                                        <v-icon color="primary">$vuetify.icons.expand</v-icon>
                                    </template>
                                    <template v-slot:header>
                                        <div><h5 :class="task.done ? 'lineThrough' : ''">{{ task.name }}</h5></div>
                                    </template>
                                    <v-card class="grey lighten-2">
                                        <v-card-text>{{ task.description }}</v-card-text>
                                    </v-card>
                                </v-expansion-panel-content>
                            </v-expansion-panel>
                        </v-flex>
                        <v-flex xs2>
                            <div>
                                <v-btn color="primary" fab small dark @click="itemDone(key)">
                                    <v-icon>done</v-icon>
                                </v-btn>
                                <v-btn color="red" fab small dark @click="removeItem(key)">
                                    <v-icon>delete</v-icon>
                                </v-btn>
                            </div>
                        </v-flex>
                    </v-layout>
                </draggable>
            </v-container>
        </v-app>
    </div>
</template>

<script>
    import Search from './Search'
    import draggable from "vuedraggable"
    export default {
        components: {
            'app-search': Search,
            draggable
        },
        data () {
            return {
                dialog: false,
                taskName: null,
                taskDescription: null,
                tasks: [],
            };
        },
        //get data from Local Storage
        mounted () {
            if (localStorage.getItem('tasks')) {
                try {
                    this.tasks = JSON.parse(localStorage.getItem('tasks'));
                } catch (e) {
                    localStorage.removeItem('tasks');
                    alert(e);
                }
            }
        },
        methods: {
            //routes to Register page
            routeToRegister () {
                this.$router.push({ name: 'register' });
            },
            //routes to Login page
            routeToLogin () {
                this.$router.push({name: 'login', params: { status: 'null' }})
            },
            // adds new Task to local storage's variable
            addTask () {
                if (!this.taskName || !this.taskDescription) {
                    return;
                }
                let value = { name: this.taskName, description: this.taskDescription };
                this.tasks.push(value);
                this.saveTask();
                this.taskName = '';
                this.taskDescription = '';
                this.dialog = false;
            },
            //saves array in Locale Storage
            saveTask () {
                localStorage.setItem('tasks', JSON.stringify(this.tasks));
            },
            //removes item from the local storage
            removeItem (index) {
                this.tasks.splice(index, 1);
                this.saveTask();
            },
            itemDone (index) {
                this.tasks[index].done = true;
                this.saveTask();
                this.tasks = JSON.parse(localStorage.getItem( 'tasks' ));
            },
            receivedData(value) {
                if (value != '')
                {
                    this.tasks = null;
                    this.tasks = value;
                }
            }
        },
    }
</script>